using System.Threading;



namespace Utilitaires
{
    class SingleInstanceApp : System.IDisposable

    {
        // Mutex
        Mutex _siMutex;
        bool _siMutexOwned;

        // Constructeur
        public SingleInstanceApp(string name)
        {
            _siMutex = new Mutex(false, name);
            _siMutexOwned = false;
        }

        // Application dj lance ?
        public bool IsRunning()
        {
            // Acquisition du mutex.
            // Si _siMutexOwned vaut true, l'application acquiert le mutex car il est "libre"
            // Sinon le mutex a dj t acquis lors du lancement d'une instance prcdente
            _siMutexOwned = _siMutex.WaitOne(0, true);
            return !(_siMutexOwned);
        }

        // Membre de IDisposable
        public void Dispose()
        {
            // Libration du mutex si il a t acquis
            if (_siMutexOwned)
                _siMutex.ReleaseMutex();
        }
    }
}
